/*-----------------------------------------------
  A simple JSON-RPC parser / formatter for node.js
-----------------------------------------------*/
module.exports = {
  response: {
    parse: function(data, callback) {
      try {
        var parsed = JSON.parse(data);

        if (!Object.hasOwnProperty.call(parsed, 'id')) {
          throw new Error('Missing required property: "id".');
        }

        if (!Object.hasOwnProperty.call(parsed, 'error')) {
          throw new Error('Missing required property: "error".');
        }

        if (!Object.hasOwnProperty.call(parsed, 'result')) {
          throw new Error('Missing required property: "result".');
        }

        callback(null, parsed);
      } catch (e) {
        return callback(e);
      }
    }
  },

  request: {
    format: function(id, method, params) {
      return JSON.stringify({
        id: id,
        method: method,
        params: params || {}
      });
    }
  }
};
